/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-02 22:01
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
/* const ll MAXN = 2e5 + 5; */
/* const ll INF = 1LL << 60; */

const int SOURCE = 0;
const int SINK = 1;
const int stationOffset = 2;
const int refineryOffset = stationOffset + 1000 + 4;
const int MAXN = refineryOffset + 1000 + 4;

int station(int i){ return stationOffset + i; }
int refinery(int i){ return refineryOffset + i; }

ll P, RR, C;

// dinic - form reference
const int INF = 1 << 30;
struct edge {
  int v, w, c, f;
};
vector<edge> edgelist;
vector<int> edgeind[MAXN], ptr, dis;
int s, t;
void addedge(int v, int w, int c) {
  edgeind[v].push_back(edgelist.size());
  edgelist.push_back({v, w, c, 0});
  edgeind[w].push_back(edgelist.size());
  edgelist.push_back({w, v, 0, 0});
}
bool bfs_din() {
  dis.assign(MAXN, -1);
  dis[s] = 0;
  queue<int> q({s});
  while (!q.empty() && dis[t] == -1) {
    int v = q.front(); q.pop();
    for (int ei : edgeind[v]) {
      edge e = edgelist[ei];
      if (dis[e.w] == -1 && e.f < e.c) {
        q.push(e.w);
        dis[e.w] = dis[v] + 1;
      }
    }
  }
  return dis[t] != -1;
}
int dfs_din(int v = s, int mf = INF) {
  if (!mf || v == t)
    return mf;
  for(;ptr[v] < ssize(edgeind[v]); ptr[v]++) {
    int ei = edgeind[v][ptr[v]];
    edge e = edgelist[ei];
    if (dis[e.w] != dis[v] + 1)
      continue;
    int tf = dfs_din(e.w, min(mf, e.c-e.f));
    if (tf) {
      edgelist[ei].f += tf;
      edgelist[ei ^ 1].f -= tf;
      return tf;
    }
  }
  return 0;
}
ll dinic() {
  ll flow = 0;
  while (1) {
    if (!bfs_din()) break;
    ptr.assign(MAXN, 0);
    while (int tf = dfs_din())
      flow += tf;
  }
  return flow;
}

struct es { int refinery, station, time; };
vector<es> storage;
vector<int> refs(MAXN), stas(MAXN);
int sum = 0;

bool p(ll minutes){
    edgelist.clear();
    R(i, MAXN) edgeind[i].clear();

    R(i, MAXN) if(refs[i]) addedge(SOURCE, refinery(i), refs[i]);
    R(i, MAXN) if(stas[i]) addedge(station(i), SINK, stas[i]);

    for(auto [r, s, t] : storage)
        if(t > minutes) break;
        else addedge(refinery(r), station(s), INF);

    return sum <= dinic();
}

ll binsearch(ll l, ll r, function<bool(ll)> pred){
  for(ll jump = r - l - 1; jump > 0; jump /= 2)
    while(not pred(l + jump)) if(l + jump >= r) return r; else l += jump;
  return l + 1;
}



void solve(){
    // Code goes here ...
    cin >> P >> RR >> C;

    R(i, P) cin >> stas[i+1];
    R(i, RR) cin >> refs[i+1];
    R(i, MAXN) sum += stas[i];

    int from, to, time;
    R(i, C){
        cin >> to >> from >> time;
        storage.emplace_back(from, to, time);
    }
    R::sort(storage, {}, &es::time);

    s = SOURCE;
    t = SINK;

    int MAX = 1e6 + 3;
    int res = binsearch(1, MAX, p);
    if(res == MAX) res = -1;

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    solve();

    return 0;
}
        
